 "File participant.self
 created by Ian Wilkinson on Wed Sep  9 12:24:06 1992

 Copyright (c) Canon Research Centre Europe, 1992.
 All rights reserved."

traits applications visualiser _AddSlotsIfAbsent: ( | ^ participant = () | )
traits participant _Define: ( |
    _ parent* = traits clonable.

    ^ synthesizeWithoutInteraction = ( | instantiationPlan. myPicF. myPic |
	visualisation: visualisation copy.
	visualisation aspects: syntheticsWarehouse participant behaviour.

	myPicF: ((unix environmentVariable: 'CRE_APP_VISUALISER'),
	    '/SelfEngineering/People/', profile nameSeenBySystem, '.rs') asString.
	myPic: ('(', myPicF, ') readcanvas ') asString.
	(unixFile exists: myPicF) ifFalse: [ myPic: ' null ' ].

	instantiationPlan: ('(', (profile name), ') (', profile nameSeenBySystem, ') (',
	    (profile homeAddress), ') (', (profile loginShell), ') ', myPic) asString.
	visualisation instantiate: (instantiationPlan,
	    syntheticsWarehouse participant instantiateWithoutInteraction) asString.
	visualisation construction.
	visualisation behaviourFor: observer On: 2 Is: 'newObserver'.
	visualisation affect: syntheticsWarehouse participant removeFromWorld.
	visualisation affect: syntheticsWarehouse participant trackMotion
    ).

    "_" synthesize = (
	visualisation: visualisation copy.

	visualisation aspects: syntheticsWarehouse participant behaviour.
	visualisation instantiate: syntheticsWarehouse participant instantiate.
	visualisation construction.
	illustrateName
    ).

    "_" illustrateName = (
	visualisation affect: ('(', name, ') ', 
	    syntheticsWarehouse participant named) asString.
    ).

    ^ changeOfName: n = (
	name: n.
	illustrateName.
    )
| )

prototypes visualiser _AddSlotsIfAbsent: ( | ^ participant = () | )
participant _Define: ( |
    _ parent* = traits participant.
    _ thisObjectPrints = true.

    "^_" name.
    ^ profile.
    ^ location.
    ^ visualisation <- fabrication.
    ^ whereabouts <- ''.
    ^ printString = 'a participant'.
| )
